

{ if like me, data sheets are just beyond your comfortable grasp, Dennis Ferron's Obex object
"Demo_74HC595_MultiPWM" is a classic... so once you understand Dennis' perfectly documented and tightly code
object.... you can then go to the data sheet to see what the data sheet actually means}

{And if level shifting seems like a real hassle... until you can build your own solution... the
74HC595 is at least half a solution.  I originally became interested in the 595 because I wanted a nifty way to control
a stepper motor, using Dennis' object made that job a snap.  Yes... I did it first without Dennis' code.
But it just wasn't very nifty:)

The 74HC595 seems like a perfect solution to most of the world's problems... and for 3 pins on your Prop, you get up to 32 lines out of
a group of 74HC595's, which can be daisey chained,  using exactly the same code that you use to control
one.

If that doesn't make your day,  you need eggs in your beer.


Rich }


con                                                

  _clkmode = xtal1 + pll16x                             ' use crystal x 16
  _xinfreq = 5_000_000                                  ' 5 MHz cyrstal (sys clock = 80 MHz)


  ' Set this to the pins you have connected to the 74HC595's
  SR_CLOCK = 9
  SR_LATCH = 8
  SR_DATA  = 6
OBJ
  tv : "TV_TEXT"
var
  long srpin,data,temp,highbit,bit,x,z
pub  start
 tv.start(12)
 highbit:=%1000                           'for 8 bits we set this binary number to %1000_0000
 dira [sr_clock]:=1
 dira[sr_latch]:=1
 dira[sr_data]:=1
 tv.str(string("Monitor ON"))
 'dira[3]:=outa[3]:=1
 z:=cnt                                'move the Prop's clock counter into a variable
 repeat 1000
    x:=shift(%1)                         'strictly speaking at this point you don't need the %
                                       'this strobes pin 0 on the 74HC595 turning on your LED for a very
                                       'brief time
    x:=shift(%0)                         'turn off the LED
                                       ' repeat loop ends here
  
 z:=(cnt-z)                             'find the elapsed clock ticks and store in z '
 z:=80000000/z                          'we are at 80_000_000... so if we want to know how many times a
                                       'a second we can loop through the repeat loop... this is it
 tv.out(13)                             'new line
                                       'if you don't see anything, you need to plug in your tv or change
                                       'tv.start
                                     
 tv.dec(z)                            'cycles per second when repeat=1
 repeat


pub shift(datain) | ldata             '595 stuff...this code was borrowed from the OBEX object for the 595
ldata:=dataIn
bit:=3                                'for 8 bits... bit:=8
repeat  4                             'we only have 1  bit... for 8 bits... repeat 8 times  
  outa[sr_clock]:=0                   'everything starts by forcing the three control lines low 
  outa[sr_data]:=0
  outa[sr_latch]:=0
  if  ldata & highbit
     outa[sr_data]:=1                 'only 1's are actually moved... 0-s are simply indicated  
                                      'by a clock without data
  outa[sr_clock]:=1                   'this repeat loop moves your binary number into volatile memory
  bit:=bit-1
  ldata:=ldata << 1
outa[sr_latch]:=1                     'once your binary value is complete... this "latches" the value
                                      'effectively shifting your value into a byte of non-volatile memory